from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, String, Int, File

Samtools_Merge_V0_1_0 = CommandToolBuilder(tool="samtools_merge", base_command=["samtools", "merge"], inputs=[ToolInput(tag="in_input_files_sorted_read", input_type=Boolean(optional=True), prefix="-n", doc=InputDocumentation(doc="Input files are sorted by read name")), ToolInput(tag="in_input_files_sorted_tag", input_type=String(optional=True), prefix="-t", doc=InputDocumentation(doc="Input files are sorted by TAG value")), ToolInput(tag="in_attach_rg_tag", input_type=Boolean(optional=True), prefix="-r", doc=InputDocumentation(doc="Attach RG tag (inferred from file names)")), ToolInput(tag="in_uncompressed_bam_output", input_type=Boolean(optional=True), prefix="-u", doc=InputDocumentation(doc="Uncompressed BAM output")), ToolInput(tag="in_overwrite_output_bam", input_type=Boolean(optional=True), prefix="-f", doc=InputDocumentation(doc="Overwrite the output BAM if exist")), ToolInput(tag="in_compress_level", input_type=Boolean(optional=True), prefix="-1", doc=InputDocumentation(doc="Compress level 1")), ToolInput(tag="in_compression_level_from", input_type=Int(optional=True), prefix="-l", doc=InputDocumentation(doc="Compression level, from 0 to 9 [-1]")), ToolInput(tag="in_merge_file_str", input_type=File(optional=True), prefix="-R", doc=InputDocumentation(doc="Merge file in the specified region STR [all]")), ToolInput(tag="in_copy_header_outbam", input_type=File(optional=True), prefix="-h", doc=InputDocumentation(doc="Copy the header in FILE to <out.bam> [in1.bam]")), ToolInput(tag="in_combine_rg_headers", input_type=Boolean(optional=True), prefix="-c", doc=InputDocumentation(doc="Combine @RG headers with colliding IDs [alter IDs to be distinct]")), ToolInput(tag="in_combine_pg_headers", input_type=Boolean(optional=True), prefix="-p", doc=InputDocumentation(doc="Combine @PG headers with colliding IDs [alter IDs to be distinct]")), ToolInput(tag="in_override_random_seed", input_type=String(optional=True), prefix="-s", doc=InputDocumentation(doc="Override random seed")), ToolInput(tag="in_list_input_bam", input_type=File(optional=True), prefix="-b", doc=InputDocumentation(doc="List of input BAM filenames, one per line [null]")), ToolInput(tag="in_use_customized_files", input_type=Boolean(optional=True), prefix="-X", doc=InputDocumentation(doc="Use customized index files")), ToolInput(tag="in_no_pg", input_type=Boolean(optional=True), prefix="--no-PG", doc=InputDocumentation(doc="do not add a PG line")), ToolInput(tag="in_input_fmt_option", input_type=File(optional=True), prefix="--input-fmt-option", doc=InputDocumentation(doc="[=VAL]\nSpecify a single input file format option in the form\nof OPTION or OPTION=VALUE")), ToolInput(tag="in_output_fmt", input_type=String(optional=True), prefix="--output-fmt", doc=InputDocumentation(doc="[,OPT[=VAL]]...\nSpecify output format (SAM, BAM, CRAM)")), ToolInput(tag="in_output_fmt_option", input_type=File(optional=True), prefix="--output-fmt-option", doc=InputDocumentation(doc="[=VAL]\nSpecify a single output file format option in the form\nof OPTION or OPTION=VALUE")), ToolInput(tag="in_reference", input_type=File(optional=True), prefix="--reference", doc=InputDocumentation(doc="Reference sequence FASTA FILE [null]")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="Number of additional threads to use [0]")), ToolInput(tag="in_write_index", input_type=Boolean(optional=True), prefix="--write-index", doc=InputDocumentation(doc="Automatically index the output files [off]")), ToolInput(tag="in_verbosity", input_type=Int(optional=True), prefix="--verbosity", doc=InputDocumentation(doc="Set level of verbosity\n")), ToolInput(tag="in_n_url_f", input_type=Boolean(optional=True), prefix="-nurlf", doc=InputDocumentation(doc="")), ToolInput(tag="in_out_dot_bam", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_in_one_dot_bam", input_type=Int(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_inn_dot_bam", input_type=String(optional=True), position=2, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_copy_header_outbam", output_type=File(optional=True), selector=InputSelector(input_to_select="in_copy_header_outbam", type_hint=File()), doc=OutputDocumentation(doc="Copy the header in FILE to <out.bam> [in1.bam]")), ToolOutput(tag="out_output_fmt_option", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_fmt_option", type_hint=File()), doc=OutputDocumentation(doc="[=VAL]\nSpecify a single output file format option in the form\nof OPTION or OPTION=VALUE"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Samtools_Merge_V0_1_0().translate("wdl", allow_empty_container=True)

